=== meson_options.txt ===
option('cli', type: 'feature', value: 'auto', description: 'Build CLI programs ("auto" means they will be built when not a subproject)')
option('static_runtime', type: 'boolean', value: false)
option('local', type: 'boolean', value: false, description: 'Adds support for local/side-by-side installation (sets rpath if needed)')
option('blob', type: 'boolean', value: false, description: 'Compile just one binary which dispatch to the right handlers based on the name used to call it')
option('wasan', type: 'boolean', value: false, description: 'Windows-specific hack to build with asan using msvc')

# Plugins
option('plugins', type: 'string', value: '', description: 'Comma separated list of plugin names')

# For Windows
option('r2_libdir', type: 'string', value: '')
option('r2_incdir', type: 'string', value: '')
option('r2_datdir', type: 'string', value: '')
option('r2_wwwroot', type: 'string', value: '')
option('r2_sdb', type: 'string', value: '')
option('r2_zigns', type: 'string', value: '')
option('r2_themes', type: 'string', value: '')
option('r2_fortunes', type: 'string', value: '')
option('r2_flags', type: 'string', value: '')
option('r2_hud', type: 'string', value: '')

option('r2_version_commit', type: 'string', value: '')
option('r2_gittap', type: 'string', value: '')
option('r2_gittip', type: 'string', value: '')
option('checks_level', type: 'integer', value: 9999, description: 'Value between 0 and 3 to enable different level of assert (see R_CHECKS_LEVEL). By default its value depends on buildtype (2 on debug, 1 on release).')
option('capstone_in_builddir', type: 'boolean', value: false, description: 'When true, capstone is downloaded in the build directory and not in the source one')
option('want_threads', type: 'boolean', value: true)
option('want_capstone', type: 'boolean', value: true)
option('use_sys_capstone', type: 'boolean', value: false)
option('use_capstone_version', type: 'combo', choices: ['v3', 'v4', 'v5'], value: 'v5')
option('use_sys_magic', type: 'boolean', value: false)
option('use_sys_zip', type: 'boolean', value: false)
option('use_sys_zlib', type: 'boolean', value: false)
option('use_sys_lz4', type: 'boolean', value: false)
option('use_sys_xxhash', type: 'boolean', value: false)
option('use_ssl', type: 'boolean', value: false)
option('use_v35', type: 'boolean', value: false)
option('use_sys_openssl', type: 'boolean', value: false)
option('static_sys_openssl', type: 'boolean', value: false)
option('use_libuv', type: 'boolean', value: true)
option('use_fork', type: 'boolean', value: true)
option('sdb_cgen', type: 'boolean', value: true)
option('use_dylink', type: 'boolean', value: true)
option('debugger', type: 'boolean', value: true)
option('want_ptrace_wrap', type: 'boolean', value: true)
option('nogpl', type: 'boolean', value: false)

option('use_webui', type: 'boolean', value: false, description: 'install different WebUIs for radare2')

option('enable_tests', type: 'boolean', value: true, description: 'Build unit tests in test/unit')
option('enable_r2r', type: 'boolean', value: true, description: 'Build r2r executable for regression ')
