=== binr/rasm2/Makefile ===
BIN=rasm2
BINDEPS=r_main

include ../../config-user.mk
include ../../libr/main/deps.mk
include ../../shlr/zip/deps.mk
include ../../shlr/java/deps.mk
include ../../shlr/capstone.mk
include ../rules.mk
LDFLAGS+=$(LINK)
